﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace SilverlightApplication17
{
	public partial class MainPage : UserControl
	{
        bool disregardUpdate = false;
		public MainPage()
		{
			InitializeComponent();
		}

        private void slider1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            this.radProgressBar.Value = e.NewValue;
        }

        private void radProgressBar_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (this.disregardUpdate)
                return;

            if (e.NewValue < 30)
            {
                this.HandleLessThan30(e.NewValue);
            }
            else
            {
                this.HandleGreaterThan30(e.NewValue);
            }
        }

        private void HandleLessThan30(double newValue)
        {
            this.radProgressBar.Foreground = new SolidColorBrush(Colors.DarkGray);
            this.radProgressBar.ClearValue(RadProgressBar.BackgroundProperty);
            this.radProgressBar.SkipValue = 0;
            this.radProgressBar.Value = newValue;
        }

        private void HandleGreaterThan30(double newValue)
        {
            this.disregardUpdate = true;
            this.radProgressBar.SkipValue = 30;
            this.radProgressBar.Value = (newValue - 30)* (10d/7d);
            this.radProgressBar.ClearValue(RadProgressBar.ForegroundProperty);
            LinearGradientBrush backgroundBrush = new LinearGradientBrush();
            backgroundBrush.EndPoint = new Point(1, 0.5);
            backgroundBrush.StartPoint = new Point(0, 0.5);
            backgroundBrush.GradientStops.Add(new GradientStop() { Color = Colors.DarkGray, Offset = 0 });
            backgroundBrush.GradientStops.Add(new GradientStop() { Color = Colors.White, Offset = 1 });
            backgroundBrush.GradientStops.Add(new GradientStop() { Color = Colors.DarkGray, Offset = 0.3 });
            backgroundBrush.GradientStops.Add(new GradientStop() { Color = Colors.White, Offset = 0.3 });
            this.radProgressBar.Background = backgroundBrush;
            this.disregardUpdate = false;     
        }
	}
}